// Datei: rc5wamp.c
// RC5 Funk Empfnger fr Winamp
// Wartet bis irgendein RC5 Code empfangen wurde und
// gibt den Gertecode und den Kommandocode jeweils
// als ein Byte auf der seriellen Schnittstelle aus.
//
// Holger Klabunde 
// 27.05.2001
// Compiler CC5x

#include "prozess.h"      // Der verwendete Prozessor

#include "rc5wamp.h"
#include "protos.h"

#include "delay.c"
#include "phase.c"
#include "serial.c"
 
unsigned char shift;   //Register fr die Abtastung
unsigned char subcode; //Der RC5 Gertecode
unsigned char comcode; //Der RC5 Kommandocode
unsigned char combuf;  //Puffer fr Kommandocode. Fr Verify
unsigned char subbuf;
unsigned char toggle;  //Das Togglebit

//*******************************************************
// Hauptprogramm
//*******************************************************
void main()
{
 unsigned char by,by1;
 
 CLRWDT;
 //Takt des PIC 4MHz, ein Zyklus = 1us
 OPTION=0b10000010; //Pullups off,Prescaler auf TMR0, 1:8

 
 TRISA=0b11111110;   //Alles Eingnge bis auf PA0
 TRISB=0b11111011;   //PB2 Ausgang , PB0,1,3,4,5,6,7 Eingang
 PORTB=0x00;
 PORTA=0x00;

 TX=0;

//Das Plugin sendet "IR" um zu sehen ob der Empfnger da ist 
//Der Empfnger antwortet mit "OK". Alles ohne CR,LF am Ende !

//Falls "IR" falsch empfangen wurde nochmal versuchen
//
repser:
 by=Receive();  //Warte auf 'I'
 if(by!='I') goto repser;

 by1=Receive(); //Warte auf 'R'
 if(by1!='R') goto repser;

 if(by=='I' && by1=='R')
  {
   Transmit('O');
   Transmit('K');
  }
 else goto repser;

 while(1) // Programm-Endlosschleife
  {

   do
    {
     by=PhaseDemod(); //Warten auf RC5 Code
    }while(by==0);    //Bis by>0

   combuf=comcode; //Eben empfangenen Code speichern
   subbuf=subcode;

   do //Code ein zweites mal empfangen. Vermeidet Fehlcodes
    {
     by=PhaseDemod(); //Warten auf RC5 Code
    }while(by==0);    //Bis by>0


   if(comcode==combuf && subcode==subbuf) //Beide Codes gleich ?
    {
     //Das Togglebit wird ignoriert !
     Transmit(subcode); //RC5 Code als Ergebnis bertragen
     Transmit(comcode); //RC5 Code als Ergebnis bertragen
     Transmit(0); //auf 6 Bytes auffllen frs Plugin
     Transmit(0); 
     Transmit(0); 
     Transmit(0); 
     Delay1ms(100); //doppeltes empfangen vermeiden
     
    } //if(comcode==combuf && subcode==subbuf)
   
  } //while(1) Endlosschleife

}
